android.app.Fragment与android.support.v4.app.Fragment不一致
android.app.Fragment与android.support.v4.app.Fragment不一致
飞上北极星 发表于7个月前
android.app.Fragment与android.support.v4.app.Fragment不一致
  • 发表于 7个月前
  • 阅读 0
  • 收藏 0
  • 点赞 0
  • 评论 0

腾讯云 技术升级10大核心产品年终让利>>>   

在看法中用到的Fragment在类型转换的时候很容易出现这种问题:

对比代码:

class MyFragmentPagerAdapter extends FragmentPagerAdapter{

		public MyFragmentPagerAdapter(FragmentManager fm) {
			super(fm);
			// TODO Auto-generated constructor stub
		}

		@Override
		public Fragment getItem(int arg0) {
			// TODO Auto-generated method stub
			Fragment ft = null;
			switch (arg0) {
			case 0:
				ft = new MainPaperFragment();
				break;

			default:
				break;
			}
			return ft;
		}

		@Override
		public int getCount() {
			// TODO Auto-generated method stub
			return MainActivity.this.tabTitle.length;
		}
	}


与:

import android.support.v4.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import com.example.kuhua.R;


public class MainPaperFragment extends Fragment {

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		View MainPaperFragmentView = inflater.inflate(R.layout.mainpaperfragmentview, container,false);
		return MainPaperFragmentView;
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onActivityCreated(savedInstanceState);
	}
}

在上述fragment中 Fragment ft = new MainPaperFragment()本质上没有错,是一种多态,但是一般开发中总容易报错;原因当然在自己,我们在用Fragment的时候大体上知道是导入的import android.support.v4.app.Fragment但是在自定义Fragment的时候容易直接用了系统的import android.app.Fragment这样就造成了所使用的api不一致。解决的方法就是记得全部都用导入的import android.support.v4.app.Fragment就ok了!

共有 人打赏支持
粉丝 0
博文 140
码字总数 0
×
飞上北极星
如果觉得我的文章对您有用,请随意打赏。您的支持将鼓励我继续创作!
* 金额(元)
¥1 ¥5 ¥10 ¥20 其他金额
打赏人
留言
* 支付类型
微信扫码支付
打赏金额:
已支付成功
打赏金额: